/*
 * Copyright 2006, U.S. Robotics Corporation
 * All Rights Reserved.
 * 
 * THIS SOFTWARE IS OFFERED "AS IS", AND U.S. Robotics GRANTS NO WARRANTIES OF
 * ANY KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. U.S.
 * Robotics SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id: wan_gpio.h,v 1.2 2007/08/23 20:06:13 dtutuianu Exp $
 */

#ifndef _wan_gpio_h_
#define _wan_gpio_h_

#include <bcmtimer.h>

#define BCMGPIO_MAXPINS		32
#define BCMGPIO_MAXINDEX	(BCMGPIO_MAXPINS - 1)
#define BCMGPIO_UNDEFINED	-1

/* GPIO type */
typedef enum bcmgpio_dirn {
	BCMGPIO_DIRN_IN = 0,
	BCMGPIO_DIRN_OUT
} bcmgpio_dirn_t;

/* WAN LED for 5464 */
int wan_gpio_led_init(void);
void wan_gpio_led_cleanup(void);
void wan_led_on(void);
void wan_led_off(void);
/* Functions to implement Buttons and LEDs on the AP, using GPIOs */
int bcmgpio_connect (int gpio_pin, bcmgpio_dirn_t gpio_dirn);
int bcmgpio_disconnect (int gpio_pin);
int bcmgpio_in (unsigned long gpio_mask, unsigned long *value);
int bcmgpio_out (unsigned long gpio_mask, unsigned long value);

#endif /* _wan_gpio_h_ */
